unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, TeEngine, Series, TeeProcs, Chart, ComCtrls;

type
  TForm1 = class(TForm)
    Button2: TButton;
    Button3: TButton;
    Edit1: TEdit;
    Edit2: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Edit3: TEdit;
    Label4: TLabel;
    Memo1: TMemo;
    ComboBox1: TComboBox;
    Label5: TLabel;
    ComboBox2: TComboBox;
    Label6: TLabel;
    ComboBox3: TComboBox;
    Label7: TLabel;
    Label8: TLabel;
    Chart1: TChart;
    Series1: TFastLineSeries;
    ProgressBar1: TProgressBar;
    Label9: TLabel;
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
implementation
 {$R *.dfm}

procedure TForm1.Button2Click(Sender: TObject);
   begin
     close;
   end;
procedure TForm1.Button3Click(Sender: TObject);
const
   a1=0.0000188;
   LAM1=0.0244;  {vozdyx}
   a2=0.0000188;
   LAM2=0.0244;  {vozdyx}

   DELTAU=0.01;
   LX=0.1;  dX=0.01;
   LR=0.7;  dR=0.05;
   LF=360;  dF=36;
var
  T:array[1..11,1..15,1..10]of real;
  dT:array[1..11,1..15,1..10]of real;
  Rt:array[1..15] of real;
   X,R,F:integer;
   time:real;
   tt: longint;  { }
   u: longint;  {     }
   tau: longint;  {   }
   PX,PR,PF:REAL;
   F34,dF34,alyfa,dR4,dRl:REAL;
 begin
   { }
{   time:=strtoint(Edit2.Text);    }
   u:=strtoint(Edit1.Text);
 {  tau:=trunc (time/deltau);    }
   PX:=dX*dX;
   PR:=dR*dR;
   PF:=dF*dF;
   {   }
   Chart1.SeriesList[0].Clear;
   Memo1.Lines.Clear;
   Edit3.Text:='';
   ProgressBar1.Max:=50000;
   ProgressBar1.Position:=0;
 { }
  FOR X:=1 TO 11 DO
   FOR R:=1 TO 15 DO
    FOR F:=1 TO 10 DO
    BEGIN
    T[X,R,F]:=0;
    dT[X,R,F]:=0;
    END;
   {     }
 {  FOR tt:=1 TO tau DO}
  FOR tt:=1 TO 50000 DO
    BEGIN
     FOR X:=2 TO 10 DO
      FOR R:=2 TO 10 DO
       FOR F:=2 TO 9 DO
       BEGIN
     {  dT[X,R,F]:=(T[X-1,R,F]-2*T[X,R,F]+T[X+1,R,F])/PX;
       dT[X,R,F]:=dT[X,R,F]+(T[X,R-1,F]-2*T[X,R,F]+T[X,R+1,F])/PR;
       dT[X,R,F]:=dT[X,R,F]-(1/dR)*(T[X,R,F]-T[X,R-1,F])/dR;
       dT[X,R,F]:=dT[X,R,F]+(1/(LR*LR))*(T[X,R,F-1]-2*T[X,R,F]+T[X,R,F+1])/PF;
       dT[X,R,F]:=a1*DELTAU*dT[X,R,F];        }

      Rt[R]:=(LR-(R-1)*dR);
      dT[X,R,F]:=(T[X-1,R,F]-2*T[X,R,F]+T[X+1,R,F])/PX;
      dT[X,R,F]:=dT[X,R,F]+(T[X,R-1,F]-2*T[X,R,F]+T[X,R+1,F])/PR;
      dT[X,R,F]:=dT[X,R,F]+(T[X,R,F]-T[X,R-1,F])/dR*Rt[R];
      dT[X,R,F]:=dT[X,R,F]+(T[X,R,F-1]-2*T[X,R,F]+T[X,R,F+1])/PF*Rt[R]*Rt[R];
      dT[X,R,F]:=a1*DELTAU*dT[X,R,F];


       END;
     FOR X:=2 TO 10 DO
      FOR R:=12 TO 14 DO
       FOR F:=2 TO 9 DO
       BEGIN
     {  dT[X,R,F]:=(T[X-1,R,F]-2*T[X,R,F]+T[X+1,R,F])/PX;
       dT[X,R,F]:=dT[X,R,F]+(T[X,R-1,F]-2*T[X,R,F]+T[X,R+1,F])/PR;
       dT[X,R,F]:=dT[X,R,F]+(1/(LR*LR))*(T[X,R,F-1]-2*T[X,R,F]+T[X,R,F+1])/PF;
       dT[X,R,F]:=dT[X,R,F]-(1/dR)*(T[X,R,F]-T[X,R-1,F])/dR;
       dT[X,R,F]:=a2*DELTAU*dT[X,R,F];      }

      Rt[R]:=(LR-(R-1)*dR);
      dT[X,R,F]:=(T[X-1,R,F]-2*T[X,R,F]+T[X+1,R,F])/PX;
      dT[X,R,F]:=dT[X,R,F]+(T[X,R-1,F]-2*T[X,R,F]+T[X,R+1,F])/PR;
      dT[X,R,F]:=dT[X,R,F]+(T[X,R,F]-T[X,R-1,F])/dR*Rt[R];
      dT[X,R,F]:=dT[X,R,F]+(T[X,R,F-1]-2*T[X,R,F]+T[X,R,F+1])/PF*Rt[R]*Rt[R];
      dT[X,R,F]:=a2*DELTAU*dT[X,R,F];       

       END;
     FOR X:=2 TO 10 DO
     FOR F:=1 TO 10 DO
      BEGIN
       T[X,15,F]:=T[X,14,F];    {  }
      END;
      FOR R:=1 TO 15 DO
      FOR F:=1 TO 10 DO
      BEGIN
      T[11,R,F]:=0;           {   }
      END;
     FOR R:=1 TO 15 DO
      FOR F:=1 TO 10 DO
      BEGIN
      T[1,R,F]:=u;            {  }
      END;
  FOR X:=2 TO 10 DO
     FOR F:=2 TO 9 DO
      BEGIN                    {  }
       T[X,11,F]:=(1/(LAM1+LAM2))*(LAM2*T[X,12,F]+LAM1*T[X,10,F]);
      END;
     FOR X:=2 TO 10 DO
      FOR R:=2 TO 14 DO
       FOR F:=2 TO 9 DO
       BEGIN
       T[X,R,F]:=T[X,R,F]+dT[X,R,F];
       END;

 {        }
      time:=tt*deltau;
      Chart1.SeriesList[0].AddXY(time,T[StrtoInt(ComboBox1.Text),StrtoInt(ComboBox2.Text),StrtoInt(ComboBox3.Text)]);

 {        }
      Memo1.Lines.Add(FloattoStr (T[StrtoInt(ComboBox1.Text),StrtoInt(ComboBox2.Text),StrtoInt(ComboBox3.Text)]));
       ProgressBar1.StepBy(1);
    end;
  {   }
  Edit3.Text:=FloattoStr(T[StrtoInt(ComboBox1.Text),StrtoInt(ComboBox2.Text),StrtoInt(ComboBox3.Text)]);
end;
{ end;}
end.
